package fr.utt.srt.lo02.projet.chatironlagrange.uno;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.text.JTextComponent;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteUno;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Bot;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Joueur;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Observer;

/**
 * 
 * Class reprsentant la fenetre principale de l'application
 * 
 * @author Yeth
 *
 */
public class Graphique extends JFrame implements Observer, ActionListener{

	/*
	 * Barre Menu en haut de la fentre
	 */
  private JMenuBar menuBar = new JMenuBar();

  /*
   * Menu fichier
   */
  private JMenu JMenuFichier = new JMenu("Fichier");
  private JMenu JMenuOption = new JMenu("Joueurs");
  private JMenu JMenuAPropos = new JMenu(" propos");

  /*
   * Item "Lancer"
   */
  private JMenuItem lancer = new JMenuItem("Nouvelle partie");
  private JMenuItem arreter = new JMenuItem("Arrter la partie");
  private JMenuItem quitter = new JMenuItem("Quitter");
  private JMenuItem aProposItem = new JMenuItem("?");
  private JMenuItem ajoutHumain = new JMenuItem("Ajouter un humain");
  private JMenuItem ajoutBot = new JMenuItem("Ajouter des Bots");
  
  /**
   * @version 2.0
   */

  private ButtonGroup bg = new ButtonGroup();

  private JButton boutonajouterjoueur = new JButton("Ajouter un joueur");
  private JFrame JFramePrincipale = new JFrame("UNO");
  private  JButton okBouton = new JButton("OK");
  private  JButton okBoutonajouterbot = new JButton("OK");
  private  JButton boutonQuitterFin = new JButton("Quitter");
  private JTextField nomJoueur = new JTextField();
  private JButton cancelBouton = new JButton("Annuler");
  private String difficulte;
  private JLabel Choix = new JLabel("nombre de bot");
  private JComboBox nombreBot=new JComboBox();
  private JRadioButton choixNiveau1 = new JRadioButton("facile");
  private JRadioButton choixNiveau2 = new JRadioButton("moyen");
  private JRadioButton choixNiveau3 = new JRadioButton("difficile");
  private boolean fini=false;
  private ArrayList<JButton> liste_bouton = new ArrayList<JButton>();
  private JFrame framePrincipale;
  private JButton bouton_piocher = new JButton();
  private ArrayList<JButton> liste_carte = new ArrayList<JButton>();
  private LinkedList<CarteUno> main = new LinkedList<CarteUno>();
  private Pioche pioche = new Pioche();
  private Talon talon = new Talon();
  private JButton boutontalon;
  private int numero_de_joueur;
  private boolean fin=false;
  private JButton boutonpiocher = new JButton("piocher");
  private JButton boutonpasser = new JButton("passer");
  private int couleur_choisi;
  private JButton boutonrouge = new JButton("rouge");
  private JButton boutonvert = new JButton("vert");
  private JButton boutonjaune = new JButton("jaune");
  private JButton boutonbleu = new JButton("bleu");
  private JTextArea console = new JTextArea("");
  private  JTextArea apropos = new JTextArea("Jeu du UNO dvelopp par Thibault Chtiron et Emilien Lagrange dans le cadre d'un projet au sein de l'UTT");
  private Panneau pan = new Panneau();
  


  /**
   * Constructeur principale de la fentre
   */
  public Graphique(String nom){
	  framePrincipale=new JFrame("UNO - "+nom);
	  
	  boutontalon=new JButton();
	  boutonpiocher.addActionListener(this);
	  okBoutonajouterbot.addActionListener(this);
	  boutonrouge.addActionListener(this);
	  boutonjaune.addActionListener(this);
	  boutonbleu.addActionListener(this);
	  boutonvert.addActionListener(this);
	  console.setSize(304,304);
	  console.setLocation(640,100);
	 
	  framePrincipale.add(console);
	  
	  
	  
	  
	  
		boutonQuitterFin.setSize(100,20);
		boutonQuitterFin.setLocation(500,900);
		boutonQuitterFin.addActionListener(this);
		framePrincipale.add(boutonQuitterFin);
		
        
		
  }
  
  public class Panneau extends JPanel {
	  public void paintComponent(Graphics g){
	    try {
	      Image img  = ImageIO.read(new File("img/Cover.jpg"));
	      g.drawImage(img, 0, 0, this.getWidth(), this.getHeight(), this);
	    } catch (IOException e) {
	      e.printStackTrace();
	    }     
	    
	  
	  }               
	}
  
  public void creerGraphique(){
	  JButton testtttt = new JButton();
	  liste_bouton.add(testtttt);
	  this.setContentPane(pan);
	    this.setTitle("Jeu UNO");
	    this.setSize(1920, 1080);
	    this.setResizable(true);
	    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    this.setLocationRelativeTo(null);  
	    this.initMenu();
	    this.setVisible(true);
	    this.setIconImage(Toolkit.getDefaultToolkit().getImage("img/test.png"));
	    
  }

  /**
   * Methode qui permet d'ajouter les lments au Menu
   */
  private void initMenu(){
	  
    /*
     * Menu Fichier
     * Menu Joueurs
     * Menu A propos
     */
    JMenuFichier.add(lancer);
    arreter.setEnabled(false);
    JMenuFichier.add(arreter);
    JMenuFichier.addSeparator();
    JMenuAPropos.add(aProposItem);
    
    /*
     * Pour quitter l'application
     */
    quitter.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent event){
        System.exit(0);
      }
    });
    JMenuFichier.add(quitter);
    
    /*
     * Pour ajouter un humain
     * Pour ajouter des bots
     */
    JMenuOption.add(ajoutHumain);
    JMenuOption.add(ajoutBot);
    /*
     * Pour accders au "?" de A propos
     */
    JMenuAPropos.add(aProposItem);
    
    /*
     * Cration d'une barre menu
     */
    menuBar.add(JMenuFichier);
    menuBar.add(JMenuOption);
    menuBar.add(JMenuAPropos);

    /*
     * Ajout de la barre de menus sur la fentre
     */
    this.setJMenuBar(menuBar);
  
      /*
       * Ajout des listeners pour lancer l'application
       */
	  lancer.addActionListener(this);
	  lancer.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, KeyEvent.CTRL_DOWN_MASK));
	  JMenuFichier.add(lancer);
	  
	  /*
	   * Ajout des listeners pour arreter l'application
	   */
	  quitter.addActionListener(this);
	  quitter.setEnabled(false);
	  quitter.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, KeyEvent.CTRL_DOWN_MASK));
	  JMenuFichier.add(quitter);
	  
	  
	  
	  /*
	   * Ajout des listeners pour ajouter bot
	   */
	  
	  ajoutBot.addActionListener(this);
	  ajoutBot.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, KeyEvent.CTRL_DOWN_MASK));
	  ajoutBot.addActionListener(this);
	  
	  /*
	   * Ajout des listeners pour ajouter un joueur
	   */
	  ajoutHumain.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W, KeyEvent.CTRL_DOWN_MASK));
	  ajoutHumain.addActionListener(this);
	  
	  /*
	   * Ajout des listeners pour aPropos
	   */
	  aProposItem.addActionListener(this);
	  
	  
	
  }
  
  
  	public void FenetreAjoutBot(){

	    JFramePrincipale.setSize(550, 130);
	    JFramePrincipale.setLocationRelativeTo(null);
	    JFramePrincipale.setResizable(false);
	    JFramePrincipale.setLayout(null);
	    JFramePrincipale.remove(apropos);
	    JFramePrincipale.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
	    JFramePrincipale.setIconImage(Toolkit.getDefaultToolkit().getImage("img/test.png"));

	   
		 /**
		  * Choix de l'icone de la fenetre
		  */
	    JLabel icon = new JLabel(new ImageIcon("images/icone.jpg"));
	    JPanel panelIcone = new JPanel();
	    panelIcone.setBackground(Color.white);
	    panelIcone.setLayout(new BorderLayout());
	    panelIcone.add(icon);

	    /**
	     * Choix du niveau des bots
	     */
	    
	   choixNiveau1.setSize(70,20);
	   choixNiveau2.setSize(70,20);
	   choixNiveau3.setSize(70,20);
	   choixNiveau1.setLocation(200,25);
	   choixNiveau2.setLocation(280,25);
	   choixNiveau3.setLocation(350,25);
	   choixNiveau1.setSelected(true);
	   
	    /**
	     * Choix du nombre de bots dans la partie
	     */
	    
	    nombreBot.addItem("1");
	    nombreBot.addItem("2");
	    nombreBot.addItem("3");
	    nombreBot.addItem("4");
	    nombreBot.addItem("5");
	    nombreBot.addItem("6");
	    nombreBot.addItem("7");
	    nombreBot.addItem("8");
	    nombreBot.setSize(150, 20);
	    nombreBot.setLocation(20,25);
	    
	    Choix.setText("nombre de bot");
	    Choix.setSize(150,20);
	    Choix.setLocation(20,0);

	    /**
	     * Ajout des boutons OK
	     */

	    okBoutonajouterbot.setSize(100,20);
	    okBoutonajouterbot.setLocation(20,50);
	    
	  

	    /**
	     * Bouton Annuler
	     */
	    cancelBouton.addActionListener(this);
	    cancelBouton.setSize(100,20);
	    cancelBouton.setLocation(130,50);
	    JFramePrincipale.add(Choix);
	    JFramePrincipale.add(choixNiveau1);
	    JFramePrincipale.add(choixNiveau2);
	    JFramePrincipale.add(choixNiveau3);
	    choixNiveau1.addActionListener(this);
	    choixNiveau2.addActionListener(this);
	    choixNiveau3.addActionListener(this);
	    JFramePrincipale.add(nombreBot);
	    JFramePrincipale.add(okBoutonajouterbot);
	    JFramePrincipale.add(cancelBouton);
	    JFramePrincipale.setVisible(true);
	    

  	}
  	
  	public void FenetreAPropos() {
  	
  		JButton okButtonn = new JButton("OK");
  		JFramePrincipale.remove(boutonajouterjoueur);
	    JFramePrincipale.setSize(450, 200);
	    JFramePrincipale.setLocationRelativeTo(null);
	    JFramePrincipale.setResizable(true);
	    JFramePrincipale.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	    JFramePrincipale.setIconImage(Toolkit.getDefaultToolkit().getImage("img/test.png"));
	    

	    
	    apropos.setSize(150,80);
		apropos.setLocation(250,20);
	    /** On souhaite un retour  ligne automatique : */
	    apropos.setLineWrap(true);

	    /** On souhaite que les mots ne soient pas coups : */
	    apropos.setWrapStyleWord(true);
	    
	    
	    /**
	     * Cration bouton OK
	     */
	    JFramePrincipale.setLayout(null);
	    liste_bouton.add(okButtonn);
	    liste_bouton.get(liste_bouton.size()-1).setLocation(150, 130);
	    liste_bouton.get(liste_bouton.size()-1).setSize(100, 20);
	    liste_bouton.get(liste_bouton.size()-1).setOpaque(true);
	    JFramePrincipale.add(liste_bouton.get(liste_bouton.size()-1));
	    
	    liste_bouton.get(liste_bouton.size()-1).addActionListener(this);

	    /**
	     * Cration bouton Annuler
	     */
	    
	    JFramePrincipale.add(apropos);
	    JFramePrincipale.setVisible(true);
	    JFramePrincipale.repaint();
	   
	   
	    
	  } 

  	public void FenetreAjoutJoueur() {
  		
  		
  		JButton okButtonn = new JButton("OK");
  		JFramePrincipale.remove(boutonajouterjoueur);
  		JFramePrincipale.remove(apropos);
	    JFramePrincipale.setSize(450, 200);
	    JFramePrincipale.setLocationRelativeTo(null);
	    JFramePrincipale.setResizable(true);
	    JFramePrincipale.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	    JFramePrincipale.setIconImage(Toolkit.getDefaultToolkit().getImage("img/test.png"));


	    /**
	     * Choix du nom
	     */
	    Choix.setSize(150,20);
	    Choix.setLocation(20,0);
	    Choix.setText("Saisir un pseudo");
	    nomJoueur.setLocation(20, 20);
	    nomJoueur.setSize(100, 20);
	   
	  
	    /**
	     * Cration bouton OK
	     */
	    JFramePrincipale.setLayout(null);
	    liste_bouton.add(okButtonn);
	    liste_bouton.get(liste_bouton.size()-1).setLocation(150, 20);
	    liste_bouton.get(liste_bouton.size()-1).setSize(100, 20);
	    liste_bouton.get(liste_bouton.size()-1).setOpaque(true);
	    JFramePrincipale.add(liste_bouton.get(liste_bouton.size()-1));
	    
	    liste_bouton.get(liste_bouton.size()-1).addActionListener(this);

	    /**
	     * Cration bouton Annuler
	     */
	    
	    
	    cancelBouton.setSize(100,20);
	    cancelBouton.setLocation(150,50);
	    JFramePrincipale.add(cancelBouton);
	    cancelBouton.addActionListener(this);
	    JFramePrincipale.add(Choix);
	    JFramePrincipale.add(nomJoueur);
	    JFramePrincipale.setVisible(true);
	    JFramePrincipale.repaint();
	    
	  }  
  public void supprimerBouton(){
	  JFramePrincipale.remove(okBouton);
	  JFramePrincipale.remove(okBoutonajouterbot);
	  JFramePrincipale.remove(cancelBouton);
	  JFramePrincipale.remove(nomJoueur);
	  JFramePrincipale.remove(nombreBot);
	  JFramePrincipale.remove(choixNiveau1);
	  JFramePrincipale.remove(choixNiveau2);
	  JFramePrincipale.remove(choixNiveau3);
	  JFramePrincipale.remove(Choix);
	  JFramePrincipale.remove(apropos);

	//  JFramePrincipale.remove(boutonQuitterFin);
	  
  }

public void actionPerformed(ActionEvent e) {
	 if(e.getSource()==liste_bouton.get(liste_bouton.size()-1)){
		  System.out.println("tu a ajout un joueur");
		  JFramePrincipale.dispose();
		  JFramePrincipale.remove(liste_bouton.get(liste_bouton.size()-1));
		  supprimerBouton();
		  Joueur J = new Joueur(nomJoueur.getText());
		  Partie.Joueurs.add(J);
		  Graphique intergraph = new Graphique(Partie.Joueurs.get(Partie.Joueurs.size()-1).getNom());
		  Partie.Joueurs.get(Partie.Joueurs.size()-1).addObserver(intergraph);
		  System.out.println(Partie.Joueurs.size());
		  System.out.println("vous avez ajout : "+Partie.Joueurs.get(Partie.Joueurs.size()-1).getNom());
		  fini=true;
	  }
	 else if(e.getSource()==cancelBouton){
		  System.out.println("tu a ajout anul");
		  JFramePrincipale.dispose();
		  supprimerBouton();
		  fini=true;
	  }
	 else if(e.getSource()==okBoutonajouterbot){
		  JFramePrincipale.dispose();
		  supprimerBouton();
		  for(int i=0;i<Integer.parseInt((String) nombreBot.getSelectedItem());i++){
		  Bot J = new Bot("BOT");
		  Partie.Joueurs.add(J);
		  System.out.println(Partie.Joueurs.size());
		  System.out.println("vous avez ajout : "+Partie.Joueurs.get(Partie.Joueurs.size()-1).getNom());
		  System.out.println("difficult : "+Partie.niveauBOT);
		  fini=true;
		  }
	  }
	 else if(e.getSource()==boutonQuitterFin){
		 	framePrincipale.dispose();
		 	supprimerBouton();
		  
	  }
	 else if(e.getSource()==ajoutHumain){
		  FenetreAjoutJoueur();
		  if(Partie.Joueurs.size()>9){
		  ajoutHumain.setEnabled(false);
		  }
	  }
	 else if(e.getSource()==ajoutBot){
		  FenetreAjoutBot();
		  ajoutBot.setEnabled(false);
	  }
	 else if(e.getSource()==aProposItem){
		 FenetreAPropos();
		 
	  }
	 else if(e.getSource()==choixNiveau1){
		 choixNiveau2.setSelected(false);
		 choixNiveau3.setSelected(false);
		 System.out.println("facile");
		 Partie.niveauBOT="facile";
	  }
	 else if(e.getSource()==choixNiveau2){
		 choixNiveau1.setSelected(false);
		 choixNiveau3.setSelected(false);
		 System.out.println("moyen");
		 Partie.niveauBOT="moyen";
	  }
	 else if(e.getSource()==choixNiveau3){
		 choixNiveau2.setSelected(false);
		 choixNiveau1.setSelected(false);
		 System.out.println("difficile");
		 Partie.niveauBOT="difficile";
	  }
	 else if(e.getSource()==lancer){
		 System.out.println("lancer");
		 Partie.Leave=true;
	  }
	 else if(e.getSource()==boutonpiocher){	 
		 System.out.println("piocher");
		 Partie.Joueurs.get(numero_de_joueur).prendreCarte(Pioche.tirerCarte());
		 main=Partie.Joueurs.get(numero_de_joueur).main;
		 viderCarte();
		 afficherCarte();
		 framePrincipale.remove(boutonpiocher);
		 boutonpasser.setSize(100,100);
		 boutonpasser.setLocation(430,100);
		 boutonpasser.addActionListener(this);
		 framePrincipale.add(boutonpasser);
		 framePrincipale.repaint();
	  }
	 else if(e.getSource()==boutonpasser){
		 framePrincipale.remove(boutonpasser);
		 fin=true;
	  }
	 else if(e.getSource()==boutonrouge){
		 framePrincipale.remove(boutonrouge);
		 framePrincipale.remove(boutonvert);
		 framePrincipale.remove(boutonjaune);
		 framePrincipale.remove(boutonbleu);
		 framePrincipale.repaint();
		 couleur_choisi=3;
		 fin=true;
	  }
	 else if(e.getSource()==boutonvert){
		 framePrincipale.remove(boutonrouge);
		 framePrincipale.remove(boutonvert);
		 framePrincipale.remove(boutonjaune);
		 framePrincipale.remove(boutonbleu);
		 framePrincipale.repaint();
		 couleur_choisi=4;
		 fin=true;
	  }
	 else if(e.getSource()==boutonbleu){
		 framePrincipale.remove(boutonrouge);
		 framePrincipale.remove(boutonvert);
		 framePrincipale.remove(boutonjaune);
		 framePrincipale.remove(boutonbleu);
		 framePrincipale.repaint();
		 couleur_choisi=2;
		 fin=true;
	  }
	 else if(e.getSource()==boutonjaune){
		 framePrincipale.remove(boutonrouge);
		 framePrincipale.remove(boutonvert);
		 framePrincipale.remove(boutonjaune);
		 framePrincipale.remove(boutonbleu);
		 framePrincipale.repaint();
		 couleur_choisi=1;
		 fin=true;
	  }
	 else{
		 for(int i=0; i<liste_carte.size();i++){
			 if(e.getSource()==liste_carte.get(i)){
				 if(main.get(i).CoupValide(main.get(i), talon)){
					 System.out.println("carte jouable");
					 Partie.talon.afficherCartePremiereTalon(Partie.Joueurs.get(numero_de_joueur).main.get(i));
					 System.out.println("talon devient : "+Partie.talon.getValeur()+" de couleur : "+Partie.talon.getCouleur());
					 Partie.Joueurs.get(numero_de_joueur).JouerCarte(i);
					 Partie.afficherJoueurEnCours(numero_de_joueur);
					 viderCarte();
					 Partie.afficherJoueurEnCours(numero_de_joueur);
					 framePrincipale.remove(boutonpasser);
					 framePrincipale.remove(boutonpiocher);
					 afficherCarte();
					 framePrincipale.repaint();
					 framePrincipale.setVisible(true);
					 fin=true;
				 }
			 }
		 }
	 }
	 
}

public void viderCarte(){
	int size=liste_carte.size();
	framePrincipale.remove(boutontalon);
	for(int i=0; i<size; i++){
		framePrincipale.remove(liste_carte.get(0));
		liste_carte.remove(0);
	}
}

public void changerTalon(){
	boutontalon.setIcon(new ImageIcon("img/"+talon.Carte.get(talon.Carte.size()-1)+".jpg"));
	framePrincipale.repaint();
}

public int  choisirCouleur(){
	boutonrouge.setSize(100,20);
	boutonvert.setSize(100,20);
	boutonjaune.setSize(100,20);
	boutonbleu.setSize(100,20);
	boutonrouge.setLocation(20,800);
	boutonrouge.setBackground(Color.RED);
	boutonjaune.setLocation(130,800);
	boutonbleu.setLocation(240,800);
	boutonvert.setLocation(350,800);
	boutonvert.setBackground(Color.GREEN);
	boutonjaune.setBackground(Color.YELLOW);
	boutonbleu.setBackground(Color.BLUE);
	framePrincipale.add(boutonrouge);
	framePrincipale.add(boutonvert);
	framePrincipale.add(boutonjaune);
	framePrincipale.add(boutonbleu);
	framePrincipale.repaint();
	fin=false;
	while(fin==false){
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	fin=false;
	return couleur_choisi;
}



public void afficherCarte(){
	int ID=20;
    framePrincipale.setSize(1920, 1080);
    framePrincipale.setLayout(null);
    framePrincipale.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    boutonpiocher.setSize(195, 304);
    boutonpiocher.setLocation(430,100);
    boutonpiocher.setIcon(new ImageIcon("img/recto.jpg"));
    framePrincipale.add(boutonpiocher);
    boutontalon.setText("");
	boutontalon.setText(talon.getValeur()+" c "+talon.getCouleur());
	boutontalon.setSize(195, 304);
	boutontalon.setLocation(200, 100);
	System.out.println(talon.Carte.get(Talon.Carte.size()-1));
	boutontalon.setIcon(new ImageIcon("img/"+talon.Carte.get(talon.Carte.size()-1)+".jpg"));
	framePrincipale.add(boutontalon);
	
	
	for(int i=0; i<main.size();i++){
		JButton bouton = new JButton(main.get(i).getValeur()+" c "+main.get(i).getCouleur());
		liste_carte.add(bouton);
		liste_carte.get(liste_carte.size()-1).setSize(195, 304);
		liste_carte.get(liste_carte.size()-1).setLocation(ID, 450);
		liste_carte.get(liste_carte.size()-1).setIcon(image(i));
		liste_carte.get(liste_carte.size()-1).addActionListener(this);
		framePrincipale.add(liste_carte.get(liste_carte.size()-1));
		ID+=150;
	}
	framePrincipale.repaint();
	framePrincipale.setVisible(true);
}

public ImageIcon image(int i){
	ImageIcon image = new ImageIcon("img/"+main.get(i)+".jpg");
	return image;
}

public void console(String message){
	console.append("\n"+message);
	framePrincipale.repaint();
}

public void update(LinkedList<CarteUno> m, Pioche p, Talon t, int numero) {
	console("C'est a vous de jouer");
	numero_de_joueur=numero;
	main=m;
	pioche=p;
	talon=t;
	JButton tt = new JButton();
	liste_bouton.add(tt);
	viderCarte();
	fin=false;
	afficherCarte();
	while(fin==false){
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		
	}
	console.setText("");
	framePrincipale.repaint();	
	}
}