package fr.utt.srt.lo02.projet.chatironlagrange.uno;

import java.util.Collections;
import java.util.LinkedList;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteChiffre;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteInversion;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteJoker;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CartePasserTour;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CartePlus2;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CartePlus4;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteUno;

/**
 * Classe qui cre les cartes du jeu de UNO
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 */

public class JeuDeCarteUno {
	
	/**
	 * Cre une liste JDC qui comprend toutes les cartes du jeu
	 */
	public static LinkedList<CarteUno> JDC;
	
	/**
	 * Instancie les cartes du jeu et les met dans la liste JDC
	 */
	public JeuDeCarteUno() {
		
		 JeuDeCarteUno.JDC = new LinkedList<CarteUno>();
		 
		 int i,j,k;
		 
		 for(i=0;i<4;i++){			
			 for(j=1;j<10;j++){ 		// on initialise  1 car il n'y a qu'une seule carte 0 par couleur
				 
				 CarteChiffre c = new CarteChiffre(j,i,1);
				
				 
				 JDC.add(c);
				 JDC.add(c);
				 
			 }
		 }
		 
		 for (i=0;i<4;i++){
			 
			 j = 0;	// une seule carte 0 par couleur
			 
			 CarteChiffre c0 = new CarteChiffre(j,i,1);
			 
			 JDC.add(c0);
		 }
		 
		 for(i=0;i<4;i++){		
			 
			 j=10; 		// carte passer tour
				 
				 CartePasserTour ctour = new CartePasserTour(j,i,10);
				
				 
				 JDC.add(ctour);
				 JDC.add(ctour);
				 
			 }
		 
		 for(i=0;i<4;i++){		
			 
			 j=11; 		// carte inversion
				 
				 CarteInversion cinversion = new CarteInversion(j,i,11);
				
				 
				 JDC.add(cinversion);
				 JDC.add(cinversion);
				 
			 }
	
		 
		 for(i=0;i<4;i++){		
			 
			 j=12; 		// carte+2
				 
				 CartePlus2 cplus2 = new CartePlus2(j,i,2);
				
				 
				 JDC.add(cplus2);
				 JDC.add(cplus2);
				 
			 }
		 
		 
		 
		 CarteJoker cjoker = new CarteJoker(13, 4,0);
		 
		 for(k=0;k<4;k++){
		 JDC.add(cjoker);
		 }
		 
		 CartePlus4 cplus4 = new CartePlus4(14,4,4);
		 
		 for(k=0;k<4;k++){
		 JDC.add(cplus4);
		 }
		 
	 }

	/**
	 * Methode qui retourne la liste de cartes
	 * 
	 * @return les cartes du jeu
	 */
	 public LinkedList<CarteUno> getCarte(){
		 System.out.println(JDC.size());
		 return JDC;
	 }
	 
	 /**
	  * Methode qui permet de melanger les cartes du jeu
	  * 
	  * @return les cartes du jeu
	  */
	 public LinkedList<CarteUno> melangerCarte(){
		 Collections.shuffle(JDC);
		 return JDC;
	 }
	 
	 /**
	  * Methode qui permet de tirer la premire carte de la pioche
	  * 
	  * @return la 1re carte du jeu
	  */
	 public CarteUno tirerCarte(){
		 return JDC.pop();
	 }
	 
	 /**
	  * 
	  */
	 public String toString() {
			// TODO Auto-generated method stub
			StringBuffer sb = new StringBuffer();
			sb.append(JDC);
			sb.append("\n");
			return sb.toString();
		}


	


}
