package fr.utt.srt.lo02.projet.chatironlagrange.uno;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;

import javax.swing.JButton;
import javax.swing.JFrame;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteUno;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Bot;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Joueur;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.Talon;

/**
 * Classe qui dcrit une partie de carte UNO
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 */

public class Partie {


	public static boolean sens = true;
	protected static String joueurEnCours;
	public static boolean presenceBOT = false;	
	public static String niveauBOT;

	static JeuDeCarteUno jdc = new JeuDeCarteUno();
	static Pioche pioche = new Pioche();
	public static Talon talon = new Talon();
	
	public static LinkedList<Joueur> Joueurs;
	
	private Scanner menu;
	private static Scanner menu2;
	private Scanner scan;
	private static Scanner tour;
	private static Scanner choix;
	private static Scanner debut;
	
	protected int couleur;
    protected int valeur;
    public static boolean Leave=false;
    private Graphique G = new Graphique("");
    private static int numero_de_joueur_precedent=0;
	
	/**
	 * Methode qui permet d'ajouter un joueur
	 */
	public void ajouterJoueur(){
		
		G.FenetreAjoutJoueur();
	}
	
	/**
	 * Methode qui permet d'ajouter un BOT
	 */
	public void ajouterBot(){
		
		G.FenetreAjoutBot();
		presenceBOT = true;
	}
		
	
	
	/**
	 * Methode qui lance le menu pour choisir d'ajouter des joueurs  la partie
	 */
	public void commencerJeu() {
		niveauBOT="facile";
		Partie.Joueurs = new LinkedList<Joueur>();
	
		System.out.println("Commencer une nouvelle partie \n");
		G.creerGraphique();
		while(true){
			if(Leave==true){
				 Partie.commencerPartie();
				 break;
			}
		}
	}
	
	/**
	 * Methode qui permet de commencer une partie
	 */
	public static void commencerPartie() {
		
		int i =  0;
		
		//System.out.println(jdc.getCarte());
		
		jdc.melangerCarte();
		
		Distribuer();
		
		
		talon.afficherCartePremiereTalon(Pioche.tirerCarte());
		
		if(talon.getValeur()==10 && talon.getActif()){
			talon.setActif(false);
			i++;
			Tour(i);
		}
		else if(talon.getValeur()==11 && talon.getActif()){
			talon.setActif(false);
			determinerSens(); 
			Tour(Joueurs.size()-1);
		}
		else if(talon.getValeur()==12 && talon.getActif()){
			talon.setActif(false);
			for(int k=0;k<2;k++){
			Joueurs.get(i).prendreCarte(Pioche.tirerCarte());
			}
			
			i++;
			Tour(i);
		}
		else if(talon.getValeur()==13 && talon.getActif()){
			talon.setActif(false);
			System.out.println(Joueurs.get(i).getNom()+ " doit choisir une couleur \n");
			
			if(Joueurs.get(i).getNom()!="BOT"){
				
				
				System.out.println("Choix 1: Jaune");
				System.out.println("Choix 2: Bleu");
				System.out.println("Choix 3: Rouge");
				System.out.println("Choix 4: Vert");
				

				debut = new Scanner(System.in);
				int choixcouleur = debut.nextInt();
				
				switch(choixcouleur){
				
				case 1 :
					
					talon.setCouleur(0);
					notifierJoueur("Couleur demande : Jaune" );

					break;
				
				case 2 :
					talon.setCouleur(1);
					notifierJoueur("Couleur demande : Bleu");

					break;
					
				case 3 :
					talon.setCouleur(2);
					notifierJoueur("Couleur demande : Rouge");

					break;
					
				case 4 :
					talon.setCouleur(3);
					notifierJoueur("Couleur demande : Vert");

					break;

				}
			
				}
				else{
								
					int num = (int)(Math.random() * 4);
					talon.setCouleur(num);
					System.out.println("Couleur demande : " +talon.getCouleur());
					
					
					
				}
			
			Tour(i);
			
		}
		else if(talon.getValeur()==14){
			System.out.println("On tire une autre carte car Plus4 tire");
			talon.afficherCartePremiereTalon(Pioche.tirerCarte());
			Tour(i);
		}
		else{		
		Tour(i);
		}
				

}
		
	/**
	 * Methode qui reprsente un tour de jeu pour un joueur
	 * 
	 * @param i qui rprsente le joueur en question
	 */
	public static void Tour(int i){
		if(Joueurs.get(numero_de_joueur_precedent).main.size()!=0){
			numero_de_joueur_precedent=i;
		//nbCarteValide(i);
	
		/*
		 * Affiche les caractristiquent de la carte Talon
		 */
		// TestTalon();
		
		afficherJoueurEnCours(i);
		ChangerTalon();
		//while(verificationMainJoueur()==false){
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
				if(Joueurs.get(i).getNom() != "BOT"){
					notifierJoueur(Joueurs.get(i).getNom()+" joue");
					Joueurs.get(i).notifyObserver(pioche, talon, i);
					for(int it=0; it<Joueurs.size();it++){
						Joueurs.get(it).changerTalon();
					}
					
					
					if(talon.getValeur()==11 && talon.getActif()){
						talon.setActif(false);
						determinerSens();
						
						System.out.println("Le sens de la partie change \n");
						notifierJoueur("Le sens de la partie change \n");
						
						if(i==0 && Joueurs.size()==2){
							i=0;
							//afficherJoueurEnCours(i);
							Tour(i);
						}
						else if(i==1 && Joueurs.size()==2){
							i=1;
							//afficherJoueurEnCours(i);
							Tour(i);
						}
				
					}
			
					else if(talon.getEffet()==2 && talon.getActif()){		//si la carte est noire et donc soit plus4 ou joker, on ne vrifie pas, on pose, c'est tout car ces cartes peut aller sur n'importe quelle couleur et mm valeur
						talon.setActif(false);
						//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
						piocher(i,2);
		
						System.out.println("Le joueurs suivant a piocher 2 cartes et passe son tour \n");
						notifierJoueur("Le joueurs suivant a piocher 2 cartes et passe son tour \n");
						
						if(sens==true){
							
							if(i==Joueurs.size()-2 && Joueurs.size()>2){
								i=0;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i!=Joueurs.size()-1 && Joueurs.size()>2){
								i=i+2;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i!=Joueurs.size()-1 && Joueurs.size()==2){
								i=0;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i==Joueurs.size()-1 && Joueurs.size()>2){
								i=1;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else{
								i=1;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
						}
						else if(sens==false){

							if(i>=2 && Joueurs.size()>2){
								i=i-2;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i==1){
								i=Joueurs.size()-1;
								//afficherJoueurEnCours(i);
								Tour(i);
							}
							else if(i==0 ){
								i=Joueurs.size()-2;
								//afficherJoueurEnCours(i);
								Tour(i);
							}

						}
					}
					
						else if(talon.getValeur()==14 && talon.getActif()){		//si la carte est noire et donc soit plus4 ou joker, on ne vrifie pas, on pose, c'est tout car ces cartes peut aller sur n'importe quelle couleur et mm valeur
							talon.setActif(false);
							//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
				
							piocher(i,4);
				
							System.out.println("Le joueurs suivant a piocher 4 cartes et passe son tour \n");
							notifierJoueur("Le joueurs suivant a piocher 4 cartes et passe son tour \n");
							
							ChangementCouleur(talon.getValeur(), i);
							if(sens==true){
								
								if(i==Joueurs.size()-2 && Joueurs.size()>2){
									i=0;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i!=Joueurs.size()-1 && Joueurs.size()>2){
									i=i+2;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i!=Joueurs.size()-1 && Joueurs.size()==2){
									i=0;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i==Joueurs.size()-1 && Joueurs.size()>2){
									i=1;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else{
									i=1;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
							}
							else if(sens==false){

								if(i>=2 && Joueurs.size()>2){
									i=i-2;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i==1){
									i=Joueurs.size()-1;
									//afficherJoueurEnCours(i);
									Tour(i);
								}
								else if(i==0 ){
									i=Joueurs.size()-2;
									//afficherJoueurEnCours(i);
									Tour(i);
								}

							}
				
							// System.out.println("CA MARCHE !!!!!!!!!!!!!!!!! Carte spciale !! COUP VALIDE");
				
						}
					
							else if(talon.getValeur()==13 && talon.getActif()){		//si la carte est noire et donc soit plus4 ou joker, on ne vrifie pas, on pose, c'est tout car ces cartes peut aller sur n'importe quelle couleur et mm valeur
								talon.setActif(false);
								//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
				
								ChangementCouleur(talon.getValeur(), i);
							}
								
								else if(talon.getValeur()==10 && talon.getActif()){	//Carte passer tour	
									talon.setActif(false);
									//System.out.println("Carte talon : " +talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(carteAPoser)));		//on ractualise la talon  l'affichage pour le prochain joueur
				
								
					
									notifierJoueur("Le joueur suivant ne peut pas jouer \n");
					
									if(sens==true){
						
										if(i==Joueurs.size()-2 && Joueurs.size()>2){
											i=0;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i!=Joueurs.size()-1 && Joueurs.size()>2){
											i=i+2;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i!=Joueurs.size()-1 && Joueurs.size()==2){
											i=0;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i==Joueurs.size()-1 && Joueurs.size()>2){
											i=1;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else{
											i=1;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
									}
									else if(sens==false){
				
										if(i>=2 && Joueurs.size()>2){
											i=i-2;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i==1){
											i=Joueurs.size()-1;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
										else if(i==0 ){
											i=Joueurs.size()-2;
											//afficherJoueurEnCours(i);
											Tour(i);
										}
			
									}	
						
								}
								
				}
				else {
					if(niveauBOT=="facile"){
						Bot.JouerFacile(i);
					}
					else if(niveauBOT == "moyen"){
						Bot.JouerMoyen(i);
					}
					else{
						Bot.JouerDifficile(i);
					}
				}
		if(Joueurs.get(i).main.size()==1){
			notifierJoueur(Joueurs.get(i).getNom()+" dit UNO !!");
		}
		if(sens==true && Joueurs.get(i).main.size()!=0){
			if(i!=Joueurs.size()-1){
				i++;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
			else{
				i=0;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
		}
		else if(sens==false && Joueurs.get(i).main.size()!=0){
			if(i!=0){
				i--;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
			else if(i==0 && Joueurs.size()>2){
				i=Joueurs.size()-1;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
			else if(i==0 && Joueurs.size()==2){
				i=Joueurs.size()-1;
				//afficherJoueurEnCours(i);
				Tour(i);
			}
		}
		else{
			notifierJoueur(Joueurs.get(i).getNom()+" a gagn");
			Leave=true;
		}
		}
		else{
			notifierJoueur(Joueurs.get(numero_de_joueur_precedent).getNom()+" a gagn");
			System.out.println("un bot a gagn");
			Score(numero_de_joueur_precedent);
		}
		}
	
		
	
	
	/**
	 * Methode qui calcul le score
	 * 
	 * @param k qui reprsente le joueur en question
	 */
	public static void Score(int k){
		int score = 0;
		int scoretot = 0;
		
			for(int i=0; i<Joueurs.size(); i++){
				for(int t=0; t<Joueurs.get(i).main.size();t++){
					// Carte Chiffre
					if(Joueurs.get(i).main.get(t).getEffet()==1){
						score+=Joueurs.get(i).main.get(t).getValeur();
						// Carte +2	
					}
					if(Joueurs.get(i).main.get(t).getEffet()==2){
						score+=20;
						// Carte Inversion	
					}
					if(Joueurs.get(i).main.get(t).getEffet()==11){
						score+=20;
						// Carte passer Tour	
					}
					if(Joueurs.get(i).main.get(t).getEffet()==10){
						score+=20;
						// Carte Joker	
					}
					if(Joueurs.get(i).main.get(t).getValeur()==13){
						score+=50;
						// Carte +4	
					}
					if(Joueurs.get(i).main.get(t).getValeur()==14){
						score+=50;
					}
				}
				Joueurs.get(i).setScore(score);
				//System.out.println("La main sc de "+Joueurs.get(i).getNom()+" est de "+score+" points");
				//System.out.println("La main de "+Joueurs.get(i).getNom()+" est de "+Joueurs.get(i).getScore()+" points");
			}
			
			for(int i=0; i<Joueurs.size(); i++){
			scoretot+=Joueurs.get(i).getScore();
			}
			notifierJoueur("Le score de "+Joueurs.get(k).getNom()+" est de "+scoretot+" points");
			
	}
		
		
	public static void ChangementCouleur(int carteAPoser, int i) {
		
		if(Joueurs.get(i).getNom()!="BOT"){
			
		int choix1=Joueurs.get(i).changerCouleur();

		
		switch(choix1){
		
		case 1 :
			
			talon.Carte.getLast().setCouleur(0);
			notifierJoueur("***** Couleur demande : " +talon.Carte.getLast().COULEURS[talon.Carte.getLast().getCouleur()]);

			break;
		
		case 2 :
			talon.Carte.getLast().setCouleur(1);
			notifierJoueur("***** Couleur demande : " +talon.Carte.getLast().COULEURS[talon.Carte.getLast().getCouleur()]);

			break;
			
		case 3 :
			talon.Carte.getLast().setCouleur(2);
			notifierJoueur("***** Couleur demande : " +talon.Carte.getLast().COULEURS[talon.Carte.getLast().getCouleur()]);

			break;
			
		case 4 :
			talon.Carte.getLast().setCouleur(3);
			notifierJoueur("***** Couleur demande : " +talon.Carte.getLast().COULEURS[talon.Carte.getLast().getCouleur()]);

			break;

		}
	
		}
		else{
						
			int num = (int)(Math.random() * 4);
			Joueurs.get(i).main.get(carteAPoser).setCouleur(num);
			notifierJoueur("***** Couleur demande : " +Joueurs.get(i).main.get(carteAPoser).COULEURS[Joueurs.get(i).main.get(carteAPoser).getCouleur()]);
			
			
			
		}
			
		
	}
	
	/**
	 * Methode qui permet de regenerer une pioche
	 */
	public static void regenererPioche(){				//on regenere une pioche si plus de cartes dans la pioche mais seulement si il y a plus de 2 cartes dans le talon sinon on ne peut regnerer la pioche
		if(Talon.Carte.size()>=2){
		for(int i=0;i<Talon.Carte.size()-2;i++){ 			//Carte.size()-1 correspond a la derniere carte de talon (getLast()) donc on s'arrete  l'avant dernier, donc -2
			notifierJoueur("Pioche regnre");
			jdc.JDC.add(Talon.Carte.remove(i));
			//System.out.println(jdc);
			Pioche.Melanger();
			//Pioche.getCarte();
		}
		}
	}
	
	/**
	 * Methode qui permet de piocher une carte
	 * 
	 * @param i
	 * @param n
	 * @return
	 */
	public static boolean piocher(int i, int n){
		
		if(sens==true){
		for(int k =0; k<n;k++){
			if(i!=Joueurs.size()-1){
				if(Pioche.pioche.JDC.size()==0){
					regenererPioche();
				}
				Joueurs.get(i+1).prendreCarte(Pioche.tirerCarte());
			}
			else{
				if(Pioche.pioche.JDC.size()==0){
					regenererPioche();
				}
				Joueurs.getFirst().prendreCarte(Pioche.tirerCarte());
			}
			
		}
		}
		else if(sens==false){
			for(int k =0; k<n;k++){
				if(i!=0){
					if(Pioche.pioche.JDC.size()==0){
						regenererPioche();
					}
					Joueurs.get(i-1).prendreCarte(Pioche.tirerCarte());
				}
				else{
					if(Pioche.pioche.JDC.size()==0){
						regenererPioche();
					}
					Joueurs.getLast().prendreCarte(Pioche.tirerCarte());
				}
			}
		}
		return false;
	
	}	
		

	/**
	 * Methode qui permet d'afficher le joueur qui doit jouer
	 * 
	 * @param i reprsente le joueur en question
	 */
	public static void afficherJoueurEnCours(int i) {
		System.out.println("Talon :  " +talon.afficherCarte()+"\n");
		System.out.println(Joueurs.get(i).getNom()+ " doit jouer \n");
		System.out.println("Main de " +Joueurs.get(i).getNom()+ " :  " );
		System.out.println(Joueurs.get(i));
		//}
	}
	
	/**
	 * Methode qui determine le sens dans lequel le jeu se droule
	 */
	public static void determinerSens() {
		
		if(sens==false){
			sens=true;
		}else if(sens==true){
			sens=false;
		}
	}
	
	/**
	 * Methode qui permet de distribuer les 7 cartes initiales aux joueurs
	 */
	
	public static void Distribuer() {
		
		int i;	
		
		Iterator<Joueur> it = Joueurs.iterator();
				
		while(it.hasNext()){
					
		Joueur J = (Joueur) it.next();
					
			for(i=0;i<7;i++){
						
			J.prendreCarte(jdc.tirerCarte());
					
			}
		}						
	}
	
		
	public void  carteTest(int valeur, int couleur, int i, int carteAPoser){
		this.valeur=Joueurs.get(i).main.get(carteAPoser).getValeur();
		this.couleur=Joueurs.get(i).main.get(carteAPoser).getCouleur();
}
	
	
	public static void TestCarteAPoser(int carteAPoser, int i){
		System.out.println("TestCarteAPoser: ");
		System.out.println("valeur carte jouer: "+Joueurs.get(i).main.get(carteAPoser).getValeur());
		System.out.println("couleur carte jouer: "+Joueurs.get(i).main.get(carteAPoser).getCouleur());
}
	
	public static boolean verificationMainJoueur(){
		
		for(int i=0;i<Joueurs.size()-1;i++){
			if(Joueurs.get(i).main.size()==0){
				System.out.println("******* Le gagnant est : " +Joueurs.get(i).getNom()+" *******");
				Score(i);
				return true;
			}
		}
		return false;
		
	}
	
	
	/**
	 * Methode qui retourne le nombre de cartes valide du joueur
	 * 
	 * @param i reprsente le joueur en question
	 * @return le nombre de cartes pouvant etre jou
	 */
	public static boolean nbCarteValide(int i){
		int nombreCarteValide=0;
		
		for(int o=0; o<Joueurs.get(i).main.size(); o++){
			
			CarteUno u = new CarteUno(Joueurs.get(i).main.get(o).getValeur(), Joueurs.get(i).main.get(o).getCouleur(), 0);

			if(u.CoupValide(u, talon)==true){
				nombreCarteValide++;
				
			}else if(Joueurs.get(i).main.get(o).getValeur()== 13){
				Joueurs.get(i).main.get(0);
				nombreCarteValide++;
			}
			else if(Joueurs.get(i).main.get(o).getValeur()==14){
				Joueurs.get(i).main.get(0);
				nombreCarteValide++;
			}
//			else if(Joueurs.get(i).main.get(o).getEffet()== 1){
//				Joueurs.get(i).main.get(0);
//				nombreCarteValide++;
//			}
			
		}if(nombreCarteValide==0){
			
			System.out.println("Vous avez "+nombreCarteValide+" carte pouvant tre jou");
			if(Pioche.pioche.JDC.size()==0){
				regenererPioche();
			}
			
			Joueurs.get(i).prendreCarte(Pioche.tirerCarte());
			notifierJoueur("Un bot  piocher une carte");
			
			if(Joueurs.get(i).main.getLast().CoupValide(Joueurs.get(i).main.getLast(), talon)==true){
				notifierJoueur("\n ************ Bonne Pioche ************ ");
				System.out.println("\n ************ Bonne Pioche ************ ");
				Tour(i);
			}
			else if(Joueurs.get(i).main.getLast().getValeur()==talon.getValeur() || Joueurs.get(i).main.getLast().getCouleur()==talon.getCouleur()){
				notifierJoueur("\n ************ Bonne Pioche ************ ");
				System.out.println("\n ************ Bonne Pioche ************ ");
//				talon.afficherCartePremiereTalon(Joueurs.get(i).main.get(Joueurs.get(i).main.size()-1));
//				Joueurs.get(i).JouerCarte(Joueurs.get(i).main.size()-1);
				Tour(i);
			}
			else if(Joueurs.get(i).main.getLast().getValeur()==13 || Joueurs.get(i).main.getLast().getValeur()==14){
				notifierJoueur("\n ************ Bonne Pioche ************ ");
				System.out.println("\n ************ Bonne Pioche ************ ");
				//ChangementCouleur(Joueurs.get(i).main.size()-1,i);
				Tour(i);
			}
			
			
			return false;
		}

			if(nombreCarteValide!=0){
			System.out.println("Vous avez "+nombreCarteValide+" cartes pouvant tre jous");
			return true;
		}
		
		return false;
		
	}

	
	public static void TestTalon(){
		System.out.println("TestTalon:");
		talon.getTalon();
	}	
	
	public static void notifierJoueur(String message){
		for(int i=0; i<Joueurs.size(); i++){
			Joueurs.get(i).changerConsole(message);
		}
	}
	public static void ChangerTalon(){
		for(int i=0; i<Joueurs.size(); i++){
			Joueurs.get(i).changerTalon();
		}
	}
}



