package fr.utt.srt.lo02.projet.chatironlagrange.uno;

import java.awt.Dimension;
import java.util.LinkedList;

import javax.swing.JComponent;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteUno;

/**
 * Classe qui dcrit le talon du jeu de UNO
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 */
public class Talon extends JComponent{
	
	public static LinkedList<CarteUno> Carte;
	
	/**
	 * Cre une liste de carte qui reprsente le talon
	 */
	public Talon(){
		Talon.Carte = new LinkedList<CarteUno>();
		
	}
	
	/**
	 * Methode qui permet d'afficher la carte du talon lors du premier tour de jeu
	 * 
	 * @param carte
	 * @return la dernire carte choisit du dbut
	 */
	
	public CarteUno afficherCartePremiereTalon(CarteUno carte) {
		
		Carte.add(carte);
		
		return Carte.getLast();	
	}
	
	/**
	 * Methode qui permet d'afficher la carte du talon
	 * 
	 * @return la derniere carte pos sur le talon
	 */
	public CarteUno afficherCarte() {
		return Carte.getLast();
	}
	
	/**
	 * Methode qui permet de modifier la couleur du talon
	 * 
	 * @param couleur choisit
	 */
	public void setCouleur(int couleur){
		Carte.getLast().setCouleur(couleur);
	}
	
	/**
	 * Methode qui permet d'obtenir la couleur de la carte du talon
	 * 
	 * @return la couleur de la carte du talon
	 */
	public int getCouleur() {
		return Carte.getLast().getCouleur();
	}
	
	/**
	 * Methode qui permet d'obtenir la valeur de la carte du talon
	 * 
	 * @return la valeur de la carte du talon
	 */
	public int getValeur(){
		return Carte.getLast().getValeur();
	}
	
	/**
	 * Methode qui permet d'obtenir l'effet de la carte du talon
	 * 
	 * @return l'effet de la carte du talon
	 */
	public int getEffet(){
		return Carte.getLast().getEffet();
	}
	
	/**
	 * Methode qui permet d'obtenir les caractristiques de la carte du talon
	 * 
	 * @return les caractristiques de la carte du talon
	 */
	public void getTalon(){
		System.out.println(getCouleur());
		System.out.println(getValeur());
		System.out.println(getEffet());
	}
	
	public boolean getActif(){
		return Carte.get(Carte.size()-1).getActif();
	}
	
	public void setActif(boolean b){
		Carte.get(Carte.size()-1).setActif(b);
	}
	
	public String toString() {
		// TODO Auto-generated method stub
		StringBuffer sb = new StringBuffer();
		sb.append(Carte);
		sb.append("\n");
		return sb.toString();
	}
}