package fr.utt.srt.lo02.projet.chatironlagrange.uno.carte;

import java.util.Scanner;

/**
 * Classe qui dcrit une carte Joker du jeu de UNO
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 */


public class CarteJoker extends CarteUno {
	
	/**
	 * Constructeur par dfaut d'une carte Joker
	 * 
	 * @param valeur de la carte
	 * @param couleur de la carte
	 * @param p qui est un identifiant unique  la carte
	 */
	public CarteJoker(int valeur, int couleur, int p) {
		super(valeur, couleur, p);
		
	}

	private static Scanner choix;

	
	/**
	 * Methode qui permet de valider la pose de la carte sur le talon
	 * 
	 * @param carte qui est la carte Joker
	 * @param talon qui reprsente la couleur et la valeur de la carte sur le talon
	 * @return true si la carte est valide, false si non
	 */
	public boolean CoupValide(int pioche){
		if(pioche>0)
			return true;
		return false;
	}
	
	/**
	 * Methode qui permet de choisir la couleur de la carte Joker
	 * 
	 */
	public void Jouer(){
		System.out.println("Choix 1: Jaune");
		System.out.println("Choix 2: Bleu");
		System.out.println("Choix 3: Rouge");
		System.out.println("Choix 4: Vert");
		

		choix = new Scanner(System.in);
		int choix1 = choix.nextInt();
		
		switch(choix1){
		
		case 1 :
			couleur=CarteUno.Vert;
			return;
		
		case 2 :
			couleur=CarteUno.Bleu;
			return;
		
		case 3 :
			couleur=CarteUno.Rouge;
			return;
		
		case 4 :
			couleur=CarteUno.Jaune;
			return;
			
		}
	}	
}
