package fr.utt.srt.lo02.projet.chatironlagrange.uno.carte;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.Talon;

/**
 * Classe qui dcrit une carte +2 du jeu de UNO
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 */


public class CartePlus2 extends CarteUno{
	
	
	/**
	 * Constructeur par dfaut d'une carte +2
	 * 
	 * @param valeur de la carte
	 * @param couleur de la carte
	 * @param p qui est un identifiant unique  la carte
	 */
	public CartePlus2(int valeur, int couleur, int p) {
		super(valeur, couleur, p);
		
	}

	/**
	 * Methode qui permet de valider la pose de la carte sur le talon
	 * 
	 * @param carte qui est la carte +2
	 * @param talon qui reprsente la couleur et la valeur de la carte sur le talon
	 * @return true si la carte est valide, false si non
	 */
	public boolean CoupValide(CartePlus2 carte, Talon talon){
		if(carte.getCouleur() == talon.getCouleur())
			return true;
		return false;
		}
	
	
}