

package fr.utt.srt.lo02.projet.chatironlagrange.uno.carte;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JComponent;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.Talon;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.Joueur;


/**
 * Classe qui dcrit une carte UNO
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 */


public class CarteUno extends JComponent implements MouseListener{

	public final static int Zero = 0;
	public final static int Un = 1;
	public final static int Deux = 2;
	public final static int Trois = 3;
	public final static int Quatre = 4;
	public final static int Cinq = 5;
	public final static int Six = 6;
	public final static int Sept = 7;
	public final static int Huit = 8;
	public final static int Neuf = 9;
	
	public final static int PasserTour = 10;
	public final static int Inversion = 11;
	public final static int Plus2 = 12;
	
	public final static int Joker = 13;
	public final static int Plus4 = 14;
	
	public final static int Jaune = 0;
	public final static int Bleu = 1;
	public final static int Rouge = 2;
	public final static int Vert = 3;
	public final static int Noir = 4;
	
	public final static String[] COULEURS = {"Jaune", "Bleu", "Rouge", "Vert","Noir"};
    public final static String[] VALEURS = {"Zero", "Un", "Deux", "Trois", "Quatre", "Cinq", "Six", "Sept", "Huit", "Neuf", "PasserTour", "Inversion", "Plus2", "Joker", "Plus4"};

    protected int couleur;
    protected int valeur;
    protected int effet;
    protected String image;
    protected Joueur joueur;
    protected boolean actif;
    
    /**
     * Methode qui permet de cre une carte UNO
     * 
     * @param valeur
     * @param couleur
     * @param p
     */
    public CarteUno (int valeur, int couleur, int p) {
    	this.setCouleur(couleur);
    	this.setValeur(valeur);
    	this.effet=p;
    	this.image="img/"+CarteUno.VALEURS[this.valeur]+CarteUno.COULEURS[this.couleur]+".jpg";
    	this.actif=true;
        }
    
    /**
     * Methode qui retourne l'image de la carte UNO
     * 
     * @return
     */
    public String getImage(){
    	return image;
        }

    /**
     * Methode qui retourne la couleur de la carte UNO
     * 
     * @return
     */
    public int getCouleur() {
		return couleur;
	}
    
    /**
     * Methode qui retourne la valeur de l'effet de la carte UNO
     * 
     * @return
     */
    public int getEffet(){
    	return effet;
    }
    
    /**
     * Methode qui permet de modifier la couleur de la carte TALON
     * 
     * @param couleur
     */
    public void setCouleur(int couleur) {
	
		    this.couleur = couleur;
	}
       
    /**
     * Methode qui retourne la valeur de la carte UNO
     * 
     * @return
     */
	public int getValeur() {
		return valeur;
	}

	/**
	 * Methode qui permet de modifier la valeur de la carte TALON
	 * 
	 * @param valeur
	 */
	public void setValeur(int valeur) {
		
		    this.valeur = valeur;
			
	}

	/**
	 * Methode qui retourne en chaine de caractre les caractristiques de la carte UNO
	 * 
	 */
    public String toString() {
    	if (valeur >= CarteUno.Zero && valeur <= CarteUno.Plus2) {
		    return 	CarteUno.VALEURS[this.valeur] + CarteUno.COULEURS[this.couleur] ; //+this.image
		    }		
    	else {
    		return 	CarteUno.VALEURS[this.valeur]; //+this.image
    	}
    }
    
    
    /**
     * Methode qui permet de valider un coup
     * 
     * @param carteTest
     * @param talon
     * @return
     */
    public boolean CoupValide(CarteUno carteTest, Talon talon){
		if(carteTest.getCouleur()==talon.getCouleur()){
			System.out.println("ok carte uno couleur");
			return true;
		}else if(carteTest.getValeur()==talon.getValeur()){
			System.out.println("ok carte uno valeur");
			return true;
		}else if(carteTest.getValeur()==13 || carteTest.getValeur()==14){
			System.out.println("ok carte uno valeur");
			return true;
		}else{
			return false;
		}	
	}
   


    /**
     * Methode appele lorsqu'on clique sur la carte
     * 
     * @param e
     */
    public void mouseClicked(MouseEvent e){
    	// joueur.JouerCarte(this);
    }
    
    
    
    /**
     * Methode appele lorsqu'on passe la souris sur la carte
     * 
     * @param e
     */
    public void mouseEntered(MouseEvent e){
    	
    }
    
    
    /**
     * Methode appele lorsqu'on presse le bouton de la souris
     * 
     * @param e
     */
    public void mousePressed(MouseEvent e){
    	
    }
    
    /**
     * Methode appele lorsqu'on relache le bouton de la souris
     * 
     * @param e
     */
    public void mouseReleased(MouseEvent e){
    	
    }
    
    
    /**
     * Methode appele lorsque le pointeur de la souris sort de la carte
     * 
     * @param e
     */
    public void mouseExited(MouseEvent e){
    	
    }
    
    public boolean getActif(){
    	return actif;
    }
    public void setActif(boolean b){
    	actif=b;
    }

}


	


