package fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.strategie.DifficileStrategie;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.strategie.FacileStrategie;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.strategie.MoyenStrategie;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur.strategie.Strategie;

/**
 * 
 * Classe qui dcrit un BOT et les stratgies associes
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 *
 */

public class Bot extends Joueur{

	/**
	 * 
	 * @param pseudo
	 */
	public Bot(String pseudo) {
		super(pseudo);
		
	}
	
	/**
	 * 
	 * @param strategiemethode
	 * @param num
	 */
	public static void jouer(Strategie strategiemethode,int num){
		strategiemethode.jouer(num);
	}
	
	/**
	 * Methode pour jouer un BOT en Facile
	 * 
	 * @param i
	 */
	public static void JouerFacile(int i) {
		System.out.println("C'est le BOT qui joue facile");
		jouer(new FacileStrategie(), i);
	}

	/**
	 * Methode pour jouer un BOT en Moyen
	 * 
	 * @param i
	 */
	public static void JouerMoyen(int i) {
		
		System.out.println("C'est le BOT qui joue moyen");
		
		jouer(new MoyenStrategie(), i);
		
		
	}

	/**
	 * Methode pour jouer un BOT en Difficile
	 * 
	 * @param i
	 */
	public static void JouerDifficile(int i) {
		System.out.println("C'est le BOT qui joue difficile");
		
		jouer(new DifficileStrategie(), i);
	}
}