package fr.utt.srt.lo02.projet.chatironlagrange.uno.joueur;

import java.util.ArrayList;
import java.util.LinkedList;

import fr.utt.srt.lo02.projet.chatironlagrange.uno.Partie;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.Pioche;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.Talon;
import fr.utt.srt.lo02.projet.chatironlagrange.uno.carte.CarteUno;

/**
 * Classe qui dcrit un joueur dans la partie
 * 
 * @author Emilien LAGRANGE
 * @author Thibault CHATIRON
 *
 */

public class Joueur implements Observable{
	
	public final static int Joueur1 = 0;
	public final static int Joueur2 = 1;
	public final static int Joueur3 = 2;
	public final static int Joueur4 = 3;
	public final static int Joueur5 = 4;
	public final static int Joueur6 = 5;
	public final static int Joueur7 = 6;
	public final static int Joueur8 = 7;	
	public final static int Joueur9 = 8;
	public final static int Joueur10 = 9;
	public ArrayList<Observer> liste_observer = new ArrayList<Observer>();
	
	private int score;
	private String pseudo;
	public LinkedList<CarteUno> main;

	public final static String[] NOM = {"Joueur1","Joueur2","Joueur3","Joueur4","Joueur5","Joueur6","Joueur7","Joueur8","Joueur9","Joueur10"};

	public void addObserver(Observer e){
		liste_observer.add(e);
	}
	
	public void notifyObserver(Pioche pioche, Talon talon, int numero){
		for(int i=0; i<liste_observer.size(); i++){
			liste_observer.get(i).update(main, pioche, talon, numero);
		}
	}
	/**
	 * Methode pour choisir le pseudo du joueur
	 * 
	 * @param pseudo
	 */
	public Joueur(String pseudo){
		this.setNom(pseudo);
		main = new LinkedList<CarteUno>();
		}
	
	/**
	 * Methode qui retourne le Nom du joueur
	 * 
	 * @return
	 */
	public String getNom(){
		return pseudo;
	}
	
	/**
	 * Methode pour modifier le Nom d'un joueur
	 * 
	 * @param pseudo
	 */
	private void setNom(String pseudo){
		this.pseudo = pseudo;
	}
	
	/**
	 * Methode qui affiche la liste des joueurs de la partie
	 * 
	 * @return
	 */
	public static LinkedList<Joueur> afficherJoueur(){
		return Partie.Joueurs;
		}
	
	/**
	 * Methode qui annonce UNO
	 * 
	 */
	public void AnnoncerUno() {
		System.out.println(" \n ********* UNO ********* \n ");
	}

	/**
	 * Methode qui annonce contre UNO
	 * 
	 */
	public void ContrerUno() {
		System.out.println("Contre UNO");
	}

	/**
	 * Methode qui permet de jouer une carte UNO
	 * 
	 * @param carte
	 */
	public void JouerCarte(int carte) {
		main.remove(carte);
		if(main.size()==1){
			AnnoncerUno();
		}
	}
	
	/**
	 * Methode qui permet de prendre une carte UNO
	 * 
	 * @param carte
	 * @return 
	 */
	public boolean prendreCarte(CarteUno carte){
		main.add(carte);
		
		return true;
    }
	
	/**
	 * Methode qui permet d'afficher la main du Joueur en indiquant le numro de sa carte, puis sa dscription
	 * 
	 */
	public String toString() {
		// TODO Auto-generated method stub
		StringBuffer sb = new StringBuffer();
		for(int i=0;i<main.size();i++){
		
		//sb.append(pseudo);
		//sb.append(" : ");
		sb.append("Carte n"+i+ " : "+main.get(i));
		sb.append("\n");
		}
		
		return sb.toString();
	}

	/**
	 * Methode qui retourne le score du joueur
	 * 
	 * @return
	 */
	public int getScore() {
		return score;
	}

	/**
	 * Methode qui permet de mettre  jour le score
	 * 
	 * @param score
	 */
	public void setScore(int score) {
		this.score = score;
	}

	public void changerTalon() {
		for(int i=0; i<liste_observer.size(); i++){
			liste_observer.get(i).changerTalon();
		}
	}
	
	public int changerCouleur() {
		int couleur=0;
		for(int i=0; i<liste_observer.size(); i++){
			couleur=liste_observer.get(i).choisirCouleur();
		}
		return couleur;
	}
	
	public int changerConsole(String message) {
		int couleur=0;
		for(int i=0; i<liste_observer.size(); i++){
			liste_observer.get(i).console(message);
		}
		return couleur;
	}
	
	





}

